<?php
defined('BASEPATH') OR exit('No direct script access allowed');


class User extends CI_Controller {

	public function __construct()
	{
		parent::__construct();	
		
		$this->load->model('User_Model');	
		$this->load->library('session');
		$this->load->library("pagination");

		
		
	}

	public function index()
	{


		if(isset($_SESSION['st_id']))
		{
		    $where = 's_id =' .$_SESSION['st_id'];
		    $join[] = array(
						'table' => 'tbl_courses',
						'condition' => 'tbl_students.course = tbl_courses.course_id', 
						'type' => 'left'
					);

		     $join[] = array(
						'table' => 'tbl_states',
						'condition' => 'tbl_students.s_state = tbl_states.state_id', 
						'type' => 'left'
					);

		
   		

			$data['profile_data'] = $this->User_Model->getData('tbl_students',$where,'','','',$join);


			$data['state_data'] = $this->User_Model->getData('tbl_states','','','','','');
 
			$this->load->view('user/my_profile',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }	
	}


   public function logout()
   {
   	    unset($_SESSION['st_id']);
        unset($_SESSION['st_name']);
         unset($_SESSION['st_email']);
         unset($_SESSION['couseId']);
       

   	   redirect('index');	

   }




	public function my_profile()
	{


		if(isset($_SESSION['st_id']))
		{
		    $where = 's_id =' .$_SESSION['st_id'];
		    $join[] = array(
						'table' => 'tbl_courses',
						'condition' => 'tbl_students.course = tbl_courses.course_id', 
						'type' => 'left'
					);

		     $join[] = array(
						'table' => 'tbl_states',
						'condition' => 'tbl_students.s_state = tbl_states.state_id', 
						'type' => 'left'
					);

		
   		

			$data['profile_data'] = $this->User_Model->getData('tbl_students',$where,'','','',$join);


			$data['state_data'] = $this->User_Model->getData('tbl_states','','','','','');
 
			$this->load->view('user/my_profile',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }
			
	   
		
		
	}

	public function update_profile()
	{
		$where = 's_id='.$_SESSION['st_id']; 
		$profile_update= $this->User_Model->updateQuery('tbl_students', $where, $_POST);
		if($profile_update)
		{
			$resp['status'] =  $status = 'success';
			$resp['redirect_url']	= site_url().'user/my_profile';
		}
		echo json_encode($resp);
	}


	public function partners()
	{
		if(isset($_SESSION['userid']))
		{
			$status =1;
		     $where = 'status =' .$status;
			$data['category_list'] = $this->User_Model->getData('tbl_categories',$where,'','cat_id','');


			$data['city_list'] = $this->User_Model->getData1('tbl_cities','','','city_name'); 

			$data['expert_datalist'] = $this->User_Model->get_approved_experts();


			// echo "<pre>";
			// print_r($data['expert_datalist']);
			// die();
 

		    $this->load->view('user/partners',$data);
		}
		else
		{
			redirect('index');
		}
	}

	public function view_portfolio($id)
	{
		if(isset($_SESSION['userid']))
		{
			$ex_id = base64_decode($id);
			
			$data['expert_data'] = $this->User_Model->get_expert_by_id($ex_id);

			
		     $where = 'ex_id =' .$ex_id;
			$data['porfolio_list'] = $this->User_Model->getData('tbl_gallery',$where,'','g_id','');

			$this->load->view('user/view_portfolio',$data);	
		}
		else
		{
			redirect('index');
		}
	}


	public function categories()
	{
		if(isset($_SESSION['userid']))
		{
			$status =1;
		    $where = 'status =' .$status;
			$data['category_list'] = $this->User_Model->getData('tbl_categories',$where,'','cat_id',''); 

			if(!empty($data['category_list']))
			{
				foreach($data['category_list'] as $key)
				{
					$cat_id[] = $key->cat_id;
				}

				  $j = 0;
		                foreach ($cat_id as  $value) {
		                    $data['count_partner'][] = $this->User_Model->count_partners_by_cat($cat_id[$j]); 
		                    $j++;
		                }
			}

			// echo "<pre>";
			// print_r($data['count_partner']);
			// die();
			$this->load->view('user/categories',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }
		
	}

	

	public function results()
	{
		if(isset($_SESSION['userid']))
		{
			$words = $this->input->get('keyword');
			$word = trim($words);

			$cat = $this->input->get('cat');
			$city =$this->input->get('city');

			$data['expert_datalist']=$this->User_Model->searchExperts($word,$cat,$city);

			$status =1;
		     $where = 'status =' .$status;
			$data['category_list'] = $this->User_Model->getData('tbl_categories',$where,'','cat_id','');


			$data['city_list'] = $this->User_Model->getData1('tbl_cities','','','city_name'); 

			 if(isset($_GET['cat']))
			 {
			     $data['cat']=trim($_GET['cat']);
			 }
			 else 
			 {
			 	$data['cat'] = "";
			 }
			   if(isset($_GET['city']))
			   {
			     $data['city']=trim($_GET['city']);
			   }
			   else
			   {
			   	$data['city']= "";
			   }

			// echo "<pre>";
			// print_r($data['expert_list']);
			// die();

			$this->load->view('user/results',$data);
		}
		else
		{
		   redirect('index');
		}

	}

	public function my_posts()
	{
		if(isset($_SESSION['userid']))
		{
		   
		     $where = 'u_id =' .$_SESSION['userid'];

		     $join[] = array(
				'table' => 'tbl_categories',
				'condition' => 'tbl_posts.c_id = tbl_categories.cat_id', 
				'type' => 'left'
			);
			$data['post_list'] = $this->User_Model->getData('tbl_posts',$where,'','post_id','',$join);

			if(!empty($data['post_list']))
		    {
			    	foreach($data['post_list'] as $key)
			    	{
			    		$post_id[] = $key->post_id;
			    	}

			    	$j=0;

			    	 
	                foreach ($post_id as  $value) {
	                   
	                    $data['count_replied_experts'][] =$this->User_Model->count_replied_experts($post_id[$j],$_SESSION['user_serial_no']);
	                    $j++;
	                }


			
		    }
		    // echo "<pre>";
		// 	print_r($data['count_replied_experts']);
		// 	die();
            
			$this->load->view('user/my_posts',$data);
		}
		else 
		{
			redirect('index');
		}

		
	}
	
	

	public function send_post()
	{
		if(isset($_SESSION['userid']))
		{
			$_POST['u_id'] = $_SESSION['userid'];
			$insert = $this->User_Model->insertQuery('tbl_posts', $_POST);

			  		if($insert)
			  		{
			  			$resp['status'] =  $status = 'success';
				      $resp['redirect_url'] =site_url('user/my_posts');
			  		}
			  		else 
			  		{
			  			$resp['status'] =  $status = 'failed';
			  		}
		   	

				echo json_encode($resp);	
		}
		else 
		{
			redirect('index');
		}
	}


	public function send_enquiry()
	{
		if(isset($_SESSION['userid']))
		{
			$_POST['u_id'] = $_SESSION['userid'];
			$insert = $this->User_Model->insertQuery('tbl_enquiries', $_POST);

			  		if($insert)
			  		{
			  			$resp['status'] =  $status = 'success';
				      $resp['redirect_url'] =site_url('user/my_enquiries');
			  		}
			  		else 
			  		{
			  			$resp['status'] =  $status = 'failed';
			  		}
		   	

				echo json_encode($resp);	
		}
		else 
		{
			redirect('index');
		}
	}


	public function my_enquiries()
	{

		if(isset($_SESSION['userid']))
		{
		   
		     $where = 'u_id =' .$_SESSION['userid'];

		       $join[] = array(
				'table' => 'tbl_experts',
				'condition' => 'tbl_enquiries.ex_id = tbl_experts.expert_id', 
				'type' => 'left'
			);
			$data['enquiry_list'] = $this->User_Model->getData('tbl_enquiries',$where,'','enquiry_id','',$join);
			$this->load->view('user/my_enquiries',$data);
		}
		else 
		{
			redirect('index');
		}

		
	}


	public function delete_post($post_id)
	{
		$where = 'post_id='.$post_id;
		$this->Admin_Model->deleteQuery('tbl_posts', $where);

		$where1 = 'p_id='.$post_id;
		$this->Admin_Model->deleteQuery('tbl_post_chat', $where1);


		redirect('user/my_posts','refresh');
	}


	public function delete_enquiry($enquiry_id)
	{
		$where = 'enquiry_id='.$enquiry_id;
		$this->Admin_Model->deleteQuery('tbl_enquiries', $where);


		$where1 = 'en_id='.$enquiry_id;
		$this->Admin_Model->deleteQuery('tbl_enquiry_chat', $where1);

		redirect('user/my_enquiries','refresh');
	}

	public function enquiry_details($id)
	{

		if(isset($_SESSION['userid']))
		{
		   $en_id = base64_decode($id);
		     $where = 'enquiry_id =' .$en_id;

		       $join[] = array(
				'table' => 'tbl_experts',
				'condition' => 'tbl_enquiries.ex_id = tbl_experts.expert_id', 
				'type' => 'left'
			);
			$data['enquiry_data'] = $this->User_Model->getData('tbl_enquiries',$where,'','','',$join);

			$cond = 'en_id =' .$en_id;

			$data['enquiry_chat_data'] = $this->User_Model->getData('tbl_enquiry_chat',$cond,'','','');

			// echo "<pre>";
			// print_r($data['enquiry_chat_data']);
			// die();
			$this->load->view('user/enquiry_details',$data);
		}
		else 
		{
			redirect('index');
		}

		
	}


	public function send_enquiry_message_expert()
	{
		if(isset($_SESSION['userid']))
		{
			$en_id = $_POST['en_id'];
			$_POST['sender'] = $_SESSION['user_serial_no'];
			$insert = $this->User_Model->insertQuery('tbl_enquiry_chat', $_POST);

			  		if($insert)
			  		{
			  			$resp['status'] =  $status = 'success';
				      
			  		}
			  		else 
			  		{
			  			$resp['status'] =  $status = 'failed';
			  		}
		   	

				echo json_encode($resp);	
		}
		else 
		{
			redirect('index');
		}
	}

	public function post_details($id)
	{

		if(isset($_SESSION['userid']))
		{
		   $p_id = base64_decode($id);
		     $where = 'post_id =' .$p_id;

		     $join[] = array(
				'table' => 'tbl_categories',
				'condition' => 'tbl_posts.c_id = tbl_categories.cat_id', 
				'type' => 'left'
			);
			$data['post_data'] = $this->User_Model->getData('tbl_posts',$where,'','','',$join);

		

			$data['post_chat_data'] = $this->User_Model->get_all_post_my_chat($p_id,$_SESSION['user_serial_no']);
			


			// echo "<pre>";
			// print_r($data['post_chat_data']);
			// die();
			$this->load->view('user/post_details',$data);
		}
		else 
		{
			redirect('index');
		}

		
	}

	public function post_reply_data()
	{
		if(isset($_SESSION['userid']))
		{
			$pid = $this->input->get('pid');
			$ex_id = $this->input->get('exid');


					// echo "<pre>";
					// print_r($pid);
					// die();
		   $p_id = base64_decode($pid);
		     $where = 'post_id =' .$p_id;

		     $join[] = array(
				'table' => 'tbl_categories',
				'condition' => 'tbl_posts.c_id = tbl_categories.cat_id', 
				'type' => 'left'
			);
			$data['post_data'] = $this->User_Model->getData('tbl_posts',$where,'','','',$join);

		

			

			$where2 = 'expert_id =' .$ex_id;

			$data['expert_data'] = $this->User_Model->getData('tbl_experts', $where2,'', '','');

			foreach($data['expert_data'] as $key)
			{
				$data['ex_sno'] = $key->expert_sno; 
				$data['ex_name'] = $key->expert_name;
			} 


			$data['post_chat_data'] = $this->User_Model->get_expert_post_chat($p_id,$_SESSION['user_serial_no'],$data['ex_sno']);

			


			// echo "<pre>";
			// print_r($data['post_chat_data']);
			// die();
			$this->load->view('user/post_reply_data',$data);
		}
		else 
		{
			redirect('index');
		}
	}


	public function send_post_message_expert()
	{
		if(isset($_SESSION['userid']))
		{
			
			$_POST['p_sender'] = $_SESSION['user_serial_no'];
			$insert = $this->User_Model->insertQuery('tbl_post_chat', $_POST);

			  		if($insert)
			  		{
			  			$resp['status'] =  $status = 'success';
				      
			  		}
			  		else 
			  		{
			  			$resp['status'] =  $status = 'failed';
			  		}
		   	

				echo json_encode($resp);	
		}
		else 
		{
			redirect('index');
		}
	}

	public function delete_post_chat()
	{
		$p_id = $_POST['p_id'];
		$ex_sno = $_POST['ex_id'];
		$u_sno = $_SESSION['user_serial_no'];

		$delete = $this->User_Model->delete_my_post_chat($p_id,$u_sno,$ex_sno);
		
		if($delete)
		{
			
			$resp['status'] =  $login_status = 'Success';
			
		}
		else 
		{
			$resp['status'] =  $login_status = 'Failure';
		}

		echo json_encode($resp);
	}


	public function password_reset()
	{
		if(isset($_SESSION['st_id']))
		{
		    $where = 's_id =' .$_SESSION['st_id'];
		   

			$data['profile_data'] = $this->User_Model->getData('tbl_students',$where,'','','');

			$this->load->view('user/password_reset',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }
			
	   
	}


	public function password_change()
	{
		$result = $this->User_Model->get_user_password($_POST['current_password'],$_POST['new_password'],$_SESSION['st_id']);
	    if($result['status']	==	1){
			$resp['status'] = 'success';
			$resp['redirect_url'] = site_url().'user/my_profile';
		}else{
			$resp['status'] = 'Incorrect current password';
			// $resp['redirect_url'] = site_url().'user/profile';
		}
		echo json_encode($resp);
	}

	public function videos()
	{
		
		if(isset($_SESSION['st_id']))
		{
			$where = 's_id =' .$_SESSION['st_id'];
		
		    $join[] = array(
						'table' => 'tbl_courses',
						'condition' => 'tbl_students.course = tbl_courses.course_id', 
						'type' => 'left'
					);

		  
			$data['profile_data'] = $this->User_Model->getData('tbl_students',$where,'','','',$join);


			foreach ($data['profile_data'] as $key ) 
			{
				$expirydate = $key->expiry_date;
				$course_name = $key->course_name;
				$courseId = $key->course;
			}

			

			if(!empty($course_name))
			{
				$data['cname'] = $course_name;
			}
			else 
			{
				$data['cname'] = 'Course not available';
			}



			 $todaydate= date('Y-m-d');

			if ($expirydate < $todaydate) 
			{
				$data['msg'] =	"Please Renew Your Account to Get Videos";		
			}
			else 
			{
				 $this->load->library('pagination');
				 $perPage=20;
					$config['base_url'] = base_url('user/videos');
					$page=0;

					if($this->input->get('page'))
					{
						$page = $this->input->get('page');
					}

					$start_index=0;
					if($page != 0)
					{
						$start_index = $perPage * ($page - 1);
					}

					$total_rows = 0;
		     
		     		 $data['all_videos'] = $this->User_Model->get_all_filter_video_limit($courseId,$perPage,$start_index);



		      		$total_rows =count($this->User_Model->get_all_filter_videos($courseId));

		       		$config['total_rows'] = $total_rows;

					$config['per_page']= $perPage;
					$config['enable_query_strings']= true;
					$config['use_page_numbers']= true;
					$config['page_query_string'] = true;
					$config['query_string_segment'] = 'page';
					$config['reuse_query_string']= true;
					$config['full_tag_open']= '<ul  class="pagination">';
					$config['full_tag_close']= '</ul>';
					// $config['first_link']= 'First';
					// $config['last_link']= 'Last';
					$config['first_tag_open']=  '<li  class="page-item"><spann class="page-link">';
					$config['first_tag_close'] = '</span></li>';
					$config['prev_link']= '&laquo';
					$config['prev_tag_open'] = '<li class="page-item"><span class="page-link">';

					$config['prev_tag_close'] = '</span></li>';
					$config['next_link']= '&raquo';
					$config['next_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['next_tag_close'] = '</span></li>';
					$config['last_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['last_tag_close'] = '</span></li>';
					$config['cur_tag_open'] = '<li class="page-item active"><a class="page-link" href="#">';
					$config['cur_tag_close'] = '</a></li>';
					$config['num_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['num_tag_close'] = '</span></li>'; 

					$this->pagination->initialize($config);
					$data['page'] =$page;
					$data['links']= $this->pagination->create_links();

					if(empty($data['all_videos']))
					{
						$data['msg'] = 'Videos not found';
					}

			}



	

			$this->load->view('user/videos',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }
		 
	   
		
		
	}


	public function pdf()
	{
		
		if(isset($_SESSION['st_id']))
		{
			$where = 's_id =' .$_SESSION['st_id'];
		
		    $join[] = array(
						'table' => 'tbl_courses',
						'condition' => 'tbl_students.course = tbl_courses.course_id', 
						'type' => 'left'
					);

		  
			$data['profile_data'] = $this->User_Model->getData('tbl_students',$where,'','','',$join);


			foreach ($data['profile_data'] as $key ) 
			{
				$expirydate = $key->expiry_date;
				$course_name = $key->course_name;
				$courseId = $key->course;
			}

			

			if(!empty($course_name))
			{
				$data['cname'] = $course_name;
			}
			else 
			{
				$data['cname'] = 'Course not available';
			}



			 $todaydate= date('Y-m-d');

			if ($expirydate < $todaydate) 
			{
				$data['msg'] =	"Please Renew Your Account to Get PDF";		
			}
			else 
			{
				 $this->load->library('pagination');
				 $perPage=20;
					$config['base_url'] = base_url('user/pdf');
					$page=0;

					if($this->input->get('page'))
					{
						$page = $this->input->get('page');
					}

					$start_index=0;
					if($page != 0)
					{
						$start_index = $perPage * ($page - 1);
					}

					$total_rows = 0;
		     
		     		 $data['all_pdf'] = $this->User_Model->get_all_filter_pdf_limit($courseId,$perPage,$start_index);



		      		$total_rows =count($this->User_Model->get_all_filter_pdf($courseId));

		       		$config['total_rows'] = $total_rows;

					$config['per_page']= $perPage;
					$config['enable_query_strings']= true;
					$config['use_page_numbers']= true;
					$config['page_query_string'] = true;
					$config['query_string_segment'] = 'page';
					$config['reuse_query_string']= true;
					$config['full_tag_open']= '<ul  class="pagination">';
					$config['full_tag_close']= '</ul>';
					// $config['first_link']= 'First';
					// $config['last_link']= 'Last';
					$config['first_tag_open']=  '<li  class="page-item"><spann class="page-link">';
					$config['first_tag_close'] = '</span></li>';
					$config['prev_link']= '&laquo';
					$config['prev_tag_open'] = '<li class="page-item"><span class="page-link">';

					$config['prev_tag_close'] = '</span></li>';
					$config['next_link']= '&raquo';
					$config['next_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['next_tag_close'] = '</span></li>';
					$config['last_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['last_tag_close'] = '</span></li>';
					$config['cur_tag_open'] = '<li class="page-item active"><a class="page-link" href="#">';
					$config['cur_tag_close'] = '</a></li>';
					$config['num_tag_open'] = '<li class="page-item"><span class="page-link">';
					$config['num_tag_close'] = '</span></li>'; 

					$this->pagination->initialize($config);
					$data['page'] =$page;
					$data['links']= $this->pagination->create_links();

					if(empty($data['all_pdf']))
					{
						$data['msg'] = 'PDF not found';
					}

					

			}

			$this->load->view('user/pdf',$data);
	    }
	    else 
	    {
	    	redirect('index');
	    }
		 
	   
		
		
	}


}